
import { CGGService } from 'cgg/Application.ts';
import { Router } from 'oak';

const app = new CGGService({ prefix: '/game-systems' });

app.route(new Router()
  .get('/', ctx => ctx.response.body = 'game-systems service')
);

app.start();
console.log('game-systems service running on ' + Deno.args.at(0));
