import { GameSystemSchema } from "./schema.ts";

const schemaJson = [
  {
    "_id": "6454820f30920b2262cd6640",
    "index": 0,
    "guid": "52724d58-ce75-4743-b6a9-8ae02b4a7450",
    "isActive": false,
    "balance": "$1,008.96",
    "picture": "http://placehold.it/32x32",
    "age": 27,
    "eyeColor": "brown",
    "name": "Taylor Bell",
    "gender": "female",
    "company": "FROSNEX",
    "email": "taylorbell@frosnex.com",
    "phone": "+1 (857) 459-2766",
    "address": "787 Brooklyn Avenue, Hiko, Florida, 6808",
    "about": "Ad ad cupidatat ea irure Lorem fugiat laboris exercitation consectetur in ea et. Quis do enim labore velit tempor voluptate ipsum proident aliqua ex excepteur exercitation. Pariatur aute nisi commodo eiusmod velit. Sit eu proident do minim culpa nulla veniam. Ipsum proident tempor nostrud exercitation occaecat sit est laborum officia do.\r\n",
    "registered": "2020-11-14T02:52:36 +07:00",
    "latitude": -42.333547,
    "longitude": -158.109059,
    "tags": [
      "proident",
      "officia",
      "cillum",
      "proident",
      "tempor",
      "exercitation",
      "Lorem"
    ],
    "friends": [
      {
        "id": 0,
        "name": "Fulton Greer"
      },
      {
        "id": 1,
        "name": "Hubbard Glass"
      },
      {
        "id": 2,
        "name": "Burt Carr"
      }
    ],
    "greeting": "Hello, Taylor Bell! You have 1 unread messages.",
    "favoriteFruit": "banana"
  },
  {
    "_id": "6454820fc0e3a34b70195552",
    "index": 1,
    "guid": "8e71b785-ad4d-4e12-a513-7385a9ba8286",
    "isActive": true,
    "balance": "$1,911.49",
    "picture": "http://placehold.it/32x32",
    "age": 27,
    "eyeColor": "green",
    "name": "Dianna Howard",
    "gender": "female",
    "company": "ZILLANET",
    "email": "diannahoward@zillanet.com",
    "phone": "+1 (962) 507-2555",
    "address": "348 Woods Place, Floris, Oklahoma, 3814",
    "about": "Officia enim aute proident tempor culpa mollit exercitation nulla. Commodo culpa ipsum ex laboris. Consequat nisi est incididunt sunt occaecat qui exercitation deserunt non et tempor. Ipsum voluptate anim veniam irure ad aute id magna sit anim non consectetur ipsum proident. Magna officia exercitation exercitation pariatur laborum proident.\r\n",
    "registered": "2019-01-03T10:15:04 +07:00",
    "latitude": -22.630118,
    "longitude": 33.280088,
    "tags": [
      "aute",
      "nisi",
      "labore",
      "deserunt",
      "nisi",
      "dolore",
      "excepteur"
    ],
    "friends": [
      {
        "id": 1,
        "name": "Whitney Hanson"
      },
      {
        "id": 2,
        "name": "Brewer Ball"
      }
    ],
    "greeting": "Hello, Dianna Howard! You have 1 unread messages.",
    "favoriteFruit": "banana"
  },
  {
    "_id": "6454820f92d45ff55d79f55f",
    "index": 2,
    "guid": "bd42ca2d-3a82-4b80-82e6-43346611ba25",
    "isActive": false,
    "balance": "$2,100.03",
    "picture": "http://placehold.it/32x32",
    "age": 40,
    "eyeColor": "green",
    "name": "Montoya Sharp",
    "gender": "male",
    "company": "SENTIA",
    "email": "montoyasharp@sentia.com",
    "phone": "+1 (909) 447-3348",
    "address": "773 Homecrest Avenue, Brambleton, Maine, 4567",
    "about": "Mollit duis commodo reprehenderit commodo exercitation occaecat veniam in. Excepteur quis deserunt aliqua sit Lorem. Fugiat dolore nulla sint proident commodo ullamco consectetur. Fugiat do eiusmod adipisicing tempor cupidatat. Consectetur tempor magna ex officia aute eiusmod. Sunt ut laboris magna eiusmod commodo voluptate cupidatat in. Eiusmod aliqua proident aliquip ex tempor duis excepteur irure dolor cillum do.\r\n",
    "registered": "2014-09-21T03:51:32 +06:00",
    "latitude": 44.616264,
    "longitude": 12.645741,
    "tags": [
      "fugiat",
      "nulla",
      "nulla",
      "commodo",
      "amet",
      "enim",
      "anim"
    ],
    "friends": [
      {
        "id": 1,
        "name": "Wynn Mathews"
      },
      {
        "id": 2,
        "name": "Love Cook"
      }
    ],
    "greeting": "Hello, Montoya Sharp! You have 8 unread messages.",
    "favoriteFruit": "apple"
  },
  {
    "_id": "6454820f75a0b1fd48ee40d1",
    "index": 3,
    "guid": "385bb445-c07f-40d6-b7ab-42c9b4c88903",
    "isActive": false,
    "balance": "$1,883.35",
    "picture": "http://placehold.it/32x32",
    "age": 40,
    "eyeColor": "brown",
    "name": "Marsh Parrish",
    "gender": "male",
    "company": "SEALOUD",
    "email": "marshparrish@sealoud.com",
    "phone": "+1 (954) 529-2585",
    "address": "138 Ebony Court, Leeper, Federated States Of Micronesia, 9374",
    "about": "Tempor esse et officia velit do in minim est eu enim. Ut irure Lorem cillum Lorem consequat proident in deserunt. Duis deserunt sit culpa ad aliqua quis. Incididunt amet dolore nostrud minim.\r\n",
    "registered": "2020-12-30T01:05:12 +07:00",
    "latitude": 65.637405,
    "longitude": 24.894416,
    "tags": [
      "quis",
      "qui",
      "consequat",
      "esse",
      "incididunt",
      "aliquip",
      "commodo"
    ],
    "friends": [
      {
        "id": 1,
        "name": "Gayle Mccarty"
      },
      {
        "id": 2,
        "name": "Janet Mcleod"
      }
    ],
    "greeting": "Hello, Marsh Parrish! You have 1 unread messages.",
    "favoriteFruit": "apple"
  },
  {
    "_id": "6454820f750a53838f37a442",
    "index": 4,
    "guid": "e5f25407-cc91-4976-87c2-f222af9e4817",
    "isActive": false,
    "balance": "$1,749.38",
    "picture": "http://placehold.it/32x32",
    "age": 33,
    "eyeColor": "green",
    "name": "Elvira Salinas",
    "gender": "female",
    "company": "ENTHAZE",
    "email": "elvirasalinas@enthaze.com",
    "phone": "+1 (957) 446-2769",
    "address": "292 Dwight Street, Shrewsbury, Wyoming, 6008",
    "about": "Aute nostrud labore id dolor amet deserunt. Lorem Lorem aliquip Lorem laborum ad ad officia adipisicing magna amet ipsum est aliquip. Sunt excepteur nulla nisi in magna ut minim enim ipsum nisi magna exercitation pariatur. Eu in et do ad quis ex excepteur do occaecat labore. Labore nulla occaecat consequat aliquip fugiat culpa labore magna aliqua. Aliqua cillum in et aliquip cupidatat Lorem eu pariatur dolore velit. Sint minim irure nostrud qui laborum fugiat sunt ex.\r\n",
    "registered": "2018-07-31T10:42:54 +06:00",
    "latitude": -22.4115,
    "longitude": 3.726494,
    "tags": [
      "cupidatat",
      "duis",
      "laborum",
      "incididunt",
      "et",
      "in",
      "sit"
    ],
    "friends": [
      {
        "id": 1,
        "name": "Alta Romero"
      },
      {
        "id": 2,
        "name": "Christian Carrillo"
      }
    ],
    "greeting": "Hello, Elvira Salinas! You have 6 unread messages.",
    "favoriteFruit": "banana"
  },
  {
    "_id": "6454820f0aa22ca7285106c8",
    "index": 5,
    "guid": "9856b273-6ade-4847-8d8e-13b27b8ddb8b",
    "isActive": false,
    "balance": "$3,662.75",
    "picture": "http://placehold.it/32x32",
    "age": 23,
    "eyeColor": "blue",
    "name": "Pearlie Sims",
    "gender": "female",
    "company": "HONOTRON",
    "email": "pearliesims@honotron.com",
    "phone": "+1 (810) 452-2724",
    "address": "435 Cadman Plaza, Mooresburg, Kentucky, 4520",
    "about": "Consequat et quis laborum laborum enim cillum do quis officia pariatur. Pariatur consectetur cillum commodo cillum non tempor incididunt consectetur Lorem laborum nostrud. Ullamco non sunt fugiat eiusmod ea voluptate duis irure proident.\r\n",
    "registered": "2020-03-24T07:59:59 +06:00",
    "latitude": -58.432669,
    "longitude": -6.30611,
    "tags": [
      "sit",
      "minim",
      "ea",
      "anim",
      "sint",
      "culpa",
      "ea"
    ],
    "friends": [
      {
        "id": 0,
        "name": "Goodman Holmes"
      },
      {
        "id": 1,
        "name": "Francesca Bowers"
      },
      {
        "id": 2,
        "name": "Mona Chapman"
      }
    ],
    "greeting": "Hello, Pearlie Sims! You have 2 unread messages.",
    "favoriteFruit": "apple"
  }
];

const SchemaSearch = new GameSystemSchema({
  name: 'Test Schema',
  accolades: '',
  allowsListBuilding: true,
  listBuildingRules: '',
  publicationRules: [],
  schemaProperties: {
    "_id": "id",
    "index": "number",
    "guid": "guid",
    "isActive": "boolean",
    "balance": "money",
    "picture": "string",
    "age": "number",
    "eyeColor": "string",
    "name": "string",
    "gender": "string",
    "company": "string",
    "email": "email",
    "phone": "phone",
    "address": "string",
    "about": "string",
    "registered": "date",
    "latitude": "number",
    "longitude": "number",
    "tags": ["string"],
    "friends": ['.'],
    "greeting": "string",
    "favoriteFruit": "string"
  }
})

console.log(SchemaSearch.search('friends[id=0]', schemaJson));
