import { Context, Middleware } from "oak";

export const debugLog = (message: string | ((arg: Context) => string)): Middleware => 
  async (ctx, next) => {
    console.log(typeof message === 'function' ? message(ctx) : message);
    await next();
  }