import { defineConfig } from 'vite'
import react from '@vitejs/plugin-react-swc'
import svgr from 'vite-plugin-svgr'

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [react(), svgr()],
  appType: 'spa',
  preview: {
    port: 6969
  },
  server: {
    proxy: {
      '/dev': {
        target: 'http://localhost:3000',
        rewrite: (p) => p.replace('/dev', '')
      }
    }
  }
})
